/// An offset that is defined relative to the first target event found by query.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct EventAlignment {
    #[serde(rename = "targetRunRid")]
    target_run_rid: super::super::super::run::api::RunRid,
    #[serde(rename = "alignTo")]
    align_to: super::EventAlignTo,
    #[builder(
        custom(type = super::super::super::super::event::SearchQuery, convert = Box::new)
    )]
    #[serde(rename = "eventQuery")]
    event_query: Box<super::super::super::super::event::SearchQuery>,
}
impl EventAlignment {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        target_run_rid: super::super::super::run::api::RunRid,
        align_to: super::EventAlignTo,
        event_query: super::super::super::super::event::SearchQuery,
    ) -> Self {
        Self::builder()
            .target_run_rid(target_run_rid)
            .align_to(align_to)
            .event_query(event_query)
            .build()
    }
    #[inline]
    pub fn target_run_rid(&self) -> &super::super::super::run::api::RunRid {
        &self.target_run_rid
    }
    #[inline]
    pub fn align_to(&self) -> &super::EventAlignTo {
        &self.align_to
    }
    #[inline]
    pub fn event_query(&self) -> &super::super::super::super::event::SearchQuery {
        &*self.event_query
    }
}
